#include <bits/stdc++.h>

using namespace std;

#define f0r(a, b) for (long long a = 0; a < b; a++)
#define f1r(a, b, c) for (long long a = b; a < c; a++)
#define f0rd(a, b) for (long long a = b; a >= 0; a--)
#define f1rd(a, b, c) for (long long a = b; a >= c; a--)
#define ms(arr, v) memset(arr, v, sizeof(arr))
#define mp(a, b) make_pair(a, b)
#define pb push_back
#define f first
#define s second
#define nl "\n"

#define ao(a, n) {for (int ele = 0; ele < n; ele++) { if (ele) cout << " "; cout << a[ele]; } cout << '\n';}

typedef long long ll;
typedef double ld;
typedef long double lld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<pii> vpi;
typedef vector<pll> vpl;

const int inf = 1e9;

const int MOD = 1e9 + 7;
typedef decay<decltype(MOD)>::type T;
struct mi {
    T val;
    explicit operator T() const { return val; }
    mi() { val = 0; }
    mi(const long long& v) {
        val = (-MOD <= v && v < MOD) ? v : v % MOD;
        if (val < 0) val += MOD;
    }
    friend ostream& operator<<(ostream& os, const mi& a) { return os << a.val; }
    friend bool operator==(const mi& a, const mi& b) { return a.val == b.val; }
    friend bool operator!=(const mi& a, const mi& b) { return !(a == b); }
    friend bool operator<(const mi& a, const mi& b) { return a.val < b.val; }
    mi operator-() const { return mi(-val); }
    mi& operator+=(const mi& m) {
        if ((val += m.val) >= MOD) val -= MOD;
        return *this;
    }
    mi& operator-=(const mi& m) {
        if ((val -= m.val) < 0) val += MOD;
        return *this;
    }
    mi& operator*=(const mi& m) {
        val = (long long)val * m.val % MOD;
        return *this;
    }
    friend mi pow(mi a, long long p) {
        mi ans = 1; assert(p >= 0);
        for (; p; p /= 2, a *= a) if (p & 1) ans *= a;
        return ans;
    }
    friend mi inv(const mi& a) { assert(a != 0); return pow(a, MOD - 2); }
    mi& operator/=(const mi& m) { return (*this) *= inv(m); }
    friend mi operator+(mi a, const mi& b) { return a += b; }
    friend mi operator-(mi a, const mi& b) { return a -= b; }
    friend mi operator*(mi a, const mi& b) { return a *= b; }
    friend mi operator/(mi a, const mi& b) { return a /= b; }
};

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int t; cin >> t;

    while (t--) {
        int n; cin >> n;
        ll arr[n];
        ll rightMx[n];
        ll rightMn[n];
        set<ll> ls;
        f0r(i, n) {
            cin >> arr[i];
        }
        rightMx[n - 1] = arr[n - 1];
        rightMn[n - 1] = arr[n - 1];
        for (int i = n - 2; i >= 0; i--) {
            rightMx[i] = max(arr[i], rightMx[i + 1]);
            rightMn[i] = min(arr[i], rightMn[i + 1]);
        }

        ls.insert(arr[0]);

        bool pos = 1;

        for (int i = 1; i < n - 2; i++) {
            ll mxR = max(abs(arr[i] - rightMx[i + 1]), abs(arr[i] - rightMn[i + 1]));
            auto it = lower_bound(ls.begin(), ls.end(), arr[i]);
            ll mnL = inf;

            //no elements >= val
            if (it == ls.end()) {
                it--;
                mnL = abs(arr[i] - *it);
            }
            else {
                mnL = abs(arr[i] - *it);
                if (it != ls.begin()) {
                    it--;
                    ll tmp = abs(arr[i] - *it);
                    mnL = min(mnL, tmp);
                }
            }
            if (mnL <= mxR) {
                //cout << i << " " << mnL << " " << mxR << endl;
                pos = 0;
                break;
            }
            ls.insert(arr[i]);
        }

        if (pos) {
            cout << 1 << nl;
        }
        else {
            cout << 0 << nl;
        }
    }
}